#!/usr/bin/python
#-*- coding:utf-8 -*-

#    Eye of GNOME renamedlg plugin version 1.0.0
#    Copyright © 2013 Marco Crippa <thekrypt77@gmail.com>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Eye of GNOME Plugins
#    http://live.gnome.org/EyeOfGnome/Plugins
#    Eye of GNOME Reference Manual
#    http://developer.gnome.org/eog/stable/index.html
#
#   2013.06.01 1.0.0

from gi.repository import GObject, Gtk, Eog
import os

global position
global filePref

position = 1
filePref = 1

class WatermarkPlugin(GObject.Object, Eog.WindowActivatable):
	window = GObject.property(type=Eog.Window)

	def __init__(self):
		GObject.Object.__init__(self)

	def do_activate(self):

		# the sidebar is where the eogMetaEdit dialog is added
		self.sidebar = self.window.get_sidebar()
		# need to track file changes in the EoG thumbview
		self.thumbview = self.window.get_thumb_view()		

#		# the EogImage of the main window
#		self.curImage = None
#		# the EogImage selected in the thumbview
#		self.thumbImage = None
#		# the EogImage whose metadata has been modified
#		self.changedImage = None
#		# flag for selection_changed_cb to note when we made the change
#		self.ignoreChange = False

		self.SW = Gtk.ScrolledWindow()
		self.SW.set_hexpand(True)
		self.SW.set_vexpand(True)

		contenitore_gen = Gtk.VBox(spacing=10)

		###POSITION###
		Hbox = Gtk.HBox(False,10)
		box_pos1 = Gtk.HBox(False,10)
		box_pos2 = Gtk.HBox(False,10)
		box_pos3 = Gtk.HBox(False,10)

		label = Gtk.Label()
		label.set_markup("<b>Position</b>")
		Hbox.pack_start(label, False, False, 10)

		btnTL = Gtk.RadioButton.new_with_label_from_widget(None, "TL")
		btnTL.set_tooltip_text("Top-Left")
		btnTL.connect("toggled", self.on_position, "1")
		box_pos1.pack_start(btnTL, False, False, 10)

		btnTC = Gtk.RadioButton.new_from_widget(btnTL)
		btnTC.set_label("TC")
		btnTC.set_tooltip_text("Top-Center")
		btnTC.connect("toggled", self.on_position, "2")
		box_pos1.pack_start(btnTC, False, False, 10)

		btnTR = Gtk.RadioButton.new_from_widget(btnTL)
		btnTR.set_label("TR")
		btnTR.set_tooltip_text("Top-Right")
		btnTR.connect("toggled", self.on_position, "3")
		box_pos1.pack_start(btnTR, False, False, 10)

		btnCL = Gtk.RadioButton.new_from_widget(btnTL)
		btnCL.set_label("CL")
		btnCL.set_tooltip_text("Center-Left")
		btnCL.connect("toggled", self.on_position, "4")
		box_pos2.pack_start(btnCL, False, False, 10)

		btnCC = Gtk.RadioButton.new_from_widget(btnTL)
		btnCC.set_label("CC")
		btnCC.set_tooltip_text("Center")
		btnCC.connect("toggled", self.on_position, "5")
		box_pos2.pack_start(btnCC, False, False, 10)

		btnCR = Gtk.RadioButton.new_from_widget(btnTL)
		btnCR.set_label("CR")
		btnCR.set_tooltip_text("Center-Right")
		btnCR.connect("toggled", self.on_position, "6")
		box_pos2.pack_start(btnCR, False, False, 10)

		btnBL = Gtk.RadioButton.new_from_widget(btnTL)
		btnBL.set_label("BL")
		btnBL.set_tooltip_text("Bottom-Left")
		btnBL.connect("toggled", self.on_position, "7")
		box_pos3.pack_start(btnBL, False, False, 10)

		btnBC = Gtk.RadioButton.new_from_widget(btnTL)
		btnBC.set_label("BC")
		btnBC.set_tooltip_text("Bottom-Center")
		btnBC.connect("toggled", self.on_position, "8")
		box_pos3.pack_start(btnBC, False, False, 10)

		btnBR = Gtk.RadioButton.new_from_widget(btnTL)
		btnBR.set_label("BR")
		btnBR.set_tooltip_text("Bottom-Right")
		btnBR.connect("toggled", self.on_position, "9")
		box_pos3.pack_start(btnBR, False, False, 10)

		contenitore_gen.pack_start(Hbox, False, False, 0)
		contenitore_gen.pack_start(box_pos1, False, False, 0)
		contenitore_gen.pack_start(box_pos2, False, False, 0)
		contenitore_gen.pack_start(box_pos3, False, False, 0)


		###MARGIN###
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label()
		label.set_markup("<b>Margin</b>")
		Hbox.pack_start(label, False, False, 10)
		contenitore_gen.pack_start(Hbox, False, False, 0)
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label("Horizontal")
		adjustmentH = Gtk.Adjustment(0, 0, 10000, 1, 10, 0)
		self.marginH = Gtk.SpinButton()
		self.marginH.set_adjustment(adjustmentH)
		self.marginH.set_value(0)
		self.marginH.set_tooltip_text("Set the horizontal margin")
		Hbox.pack_start(label, False, False, 15)
		Hbox.pack_start(self.marginH, False, False, 0)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label("Vertical")
		adjustmentV = Gtk.Adjustment(0, 0, 10000, 1, 10, 0)
		self.marginV = Gtk.SpinButton()
		self.marginV.set_adjustment(adjustmentV)
		self.marginV.set_value(0)
		self.marginV.set_tooltip_text("Set the vertical margin")
		Hbox.pack_start(label, False, False, 15)
		Hbox.pack_start(self.marginV, False, False, 0)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		###OPACITY###
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label()
		label.set_markup("<b>Opacity</b>")
		Hbox.pack_start(label, False, False, 10)

		adjustmentO = Gtk.Adjustment(0, 0, 100, 1, 10, 0)
		self.opacity = Gtk.SpinButton()
		self.opacity.set_adjustment(adjustmentO)
		self.opacity.set_value(100)
		self.opacity.set_tooltip_text("Set the opacity of the watermark")
		Hbox.pack_start(self.opacity, False, False, 0)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		###DIMENSION###
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label()
		label.set_markup("<b>Dimension</b>")
		Hbox.pack_start(label, False, False, 10)
		contenitore_gen.pack_start(Hbox, False, False, 0)
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label("width")
		adjustmentW = Gtk.Adjustment(0, 0, 10000, 1, 10, 0)
		self.width = Gtk.SpinButton()
		self.width.set_adjustment(adjustmentW)
		self.width.set_value(0)
		self.width.set_tooltip_text("Set watermark's width.\nIf 0 uses watermark's original size")
		Hbox.pack_start(label, False, False, 15)
		Hbox.pack_start(self.width, False, False, 0)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label("Height")
		adjustmentHg = Gtk.Adjustment(0, 0, 10000, 1, 10, 0)
		self.height = Gtk.SpinButton()
		self.height.set_adjustment(adjustmentHg)
		self.height.set_value(0)
		self.height.set_tooltip_text("Set watermark's height.\nIf 0 uses watermark's original size")
		Hbox.pack_start(label, False, False, 15)
		Hbox.pack_start(self.height, False, False, 0)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		###FILE###
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label()
		label.set_markup("<b>Watermark</b>")
		contenitore_gen.pack_start(Hbox, False, False, 0)
		Hbox.pack_start(label, False, False, 10)

		Hbox = Gtk.HBox(False,10)
		self.btnWatermark = Gtk.FileChooserButton("Select A File")
		self.btnWatermark.set_size_request(100,30)
		self.btnWatermark.set_tooltip_text("Choose the watermark")
		Hbox.pack_start(self.btnWatermark, False, False, 10)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		###FILENAME###
		box_append = Gtk.HBox(False,10)
		box_resize = Gtk.HBox(False,10)
		box_path = Gtk.HBox(False,10)
		box_button = Gtk.HBox(False,0)
		Hbox = Gtk.HBox(False,10)
		label = Gtk.Label()
		label.set_markup("<b>Output filename</b>")
		Hbox.pack_start(label, False, False, 10)
		contenitore_gen.pack_start(Hbox, False, False, 0)

		btnAppend = Gtk.RadioButton.new_with_label_from_widget(None, "Append:")
		btnAppend.connect("toggled", self.on_button_filename, "1")
		box_append.pack_start(btnAppend, False, False, 10)

		btnPlace = Gtk.RadioButton.new_from_widget(btnAppend)
		btnPlace.set_label("Resize in place")
		btnPlace.connect("toggled", self.on_button_filename, "2")
		box_resize.pack_start(btnPlace, False, False, 10)

		btnPath = Gtk.RadioButton.new_from_widget(btnAppend)
		btnPath.set_label("Save in:")
		btnPath.connect("toggled", self.on_button_filename, "3")
		box_path.pack_start(btnPath, False, False, 10)

		self.append = Gtk.Entry()
		self.append.set_text(".watermark")
		box_append.pack_start(self.append, False, False, 0)

		self.btnFolder = Gtk.FileChooserButton("Select A Folder")
		self.btnFolder.set_action(Gtk.FileChooserAction.SELECT_FOLDER)
		self.btnFolder.connect("show", self.SetFolder)

		box_path.pack_start(self.btnFolder, False, False, 0)

		btnPreview = Gtk.Button(label="Preview")
		btnPreview.connect("clicked", self.on_preview)
		btnPreview.set_size_request(100,30)
		box_button.pack_start(btnPreview, True, False, 0)

		btnGo = Gtk.Button(label="Add watermark")
		btnGo.connect("clicked", self.on_watermark)
		btnGo.set_size_request(100,30)
		box_button.pack_start(btnGo, True, False, 0)
	
		contenitore_gen.pack_start(box_append, False, False, 0)
		contenitore_gen.pack_start(box_resize, False, False, 0)
		contenitore_gen.pack_start(box_path, False, False, 0)
		contenitore_gen.pack_start(box_button, False, False, 0)

		self.SW.add_with_viewport(contenitore_gen)

		self.SW.show_all()
		#add my dialog to the sidebar
		Eog.Sidebar.add_page(self.sidebar,"Watermark", self.SW)


	def do_deactivate(self):
		Eog.Sidebar.remove_page(self.sidebar, self.SW)

	def on_watermark(self, action, data=None):
		imgList = self.thumbview.get_selected_images()
		if imgList == None or self.btnWatermark.get_filename()==None or self.btnFolder.get_filename()==None:
			return
		else:
			for a in range ( 0, len(imgList) ):
				name = imgList[a].get_uri_for_display()[7:]
				fn = "\""+self.FileName(name)+"\""
					
				nomeTmp="-"
				orient = "convert \""+name+"\" -auto-orient +depth miff:"+nomeTmp+" | "

				cs = "composite \""+self.btnWatermark.get_filename()+"\" "

				alpha= "-dissolve "+str(int(self.opacity.get_value()))+" "
				
				gr=self.setGravity(position)
				gravity= "-gravity "+gr+" "
				
				if self.width.get_value()==0 or self.height.get_value()==0:
					wh=""
				else:
					wh=str(int(self.width.get_value()))+"x"+str(int(self.height.get_value()))
				m="+"+str(int(self.marginH.get_value()))+"+"+str(int(self.marginV.get_value()))+" "
				geometry="-geometry "+wh+m

				cmd=orient+cs+alpha+gravity+geometry+" "+nomeTmp+" "+fn+""

#				print cmd
				s=os.system(cmd)

	def on_preview(self, w):
		imgList = self.thumbview.get_first_selected_image()
		if imgList == None or self.btnWatermark.get_filename()==None or self.btnFolder.get_filename()==None:
			return
		else:
			name = imgList.get_uri_for_display()[7:]
			fn = "\""+self.FileName(name)+"\""
			
			nomeTmp="-"
			orient = "convert \""+name+"\" -auto-orient +depth miff:"+nomeTmp+" | "

			cs = "composite \""+self.btnWatermark.get_filename()+"\" "

			alpha= "-dissolve "+str(int(self.opacity.get_value()))+" "
		
			gr=self.setGravity(position)
			gravity= "-gravity "+gr+" "
		
			if self.width.get_value()==0 or self.height.get_value()==0:
				wh=""
			else:
				wh=str(int(self.width.get_value()))+"x"+str(int(self.height.get_value()))
			m="+"+str(int(self.marginH.get_value()))+"+"+str(int(self.marginV.get_value()))+" "
			geometry="-geometry "+wh+m

			cmd=orient+cs+alpha+gravity+geometry+" "+nomeTmp+" miff:- | display - "

#			print cmd
			s=os.system(cmd)

	def SetFolder(self,w):
		self.btnFolder.set_current_folder(self.btnFolder.get_filename())
	
	def on_position(self, button, name):
		global position
		if button.get_active():
			position = int(name)

	def on_button_filename(self, button, name):
		global filePref
		if button.get_active():
			filePref = int(name)

	def FileName(self,f):
		if filePref==1:
			File = os.path.splitext(f)[0]+self.append.get_text()+os.path.splitext(f)[1]
		elif filePref==2:
			File = f
		else:
			File = os.path.join( self.btnFolder.get_filename(),os.path.split(f)[1] )
		return File

	def setGravity(self, g):
		if g == 1:
			gr = "NorthWest"
		elif g == 2:
			gr = "North"
		elif g == 3:
			gr = "NorthEast"
		elif g == 4:
			gr = "West"
		elif g == 5:
			gr = "Center"
		elif g == 6:
			gr = "East"
		elif g == 7:
			gr = "SouthWest"
		elif g == 8:
			gr = "South"
		elif g == 9:
			gr = "SouthEast"
		
		return gr

